/**
 * Color switch js
 *
 * last update : 2014/07/17
 **/

$(function(){
	// ------------------------------------------------------------------------
	// Image switch
	// ------------------------------------------------------------------------
	var $colorChangeContainer = $('.imageSwitch');

	// event
	var COLOR_CHANGE_IMAGE_LOAD   = 'colorChangeImageLoad';
	var COLOR_CHANGE_IMAGE_LOADED = 'colorChangeImageLoaded';
	var COLOR_CHANGE_ICON_OVER    = 'colorChnageiconOver';
	var COLOR_CHANGE_ICON_OUT     = 'colorChnageiconOut';
	var COLOR_CHANGE_ICON_CLICK   = 'colorChnageiconClick';

	// type
	var TYPE_ONCE   = 'typeOnce';
	var TYPE_PLURAL = 'typePlural';

	var colorChangeObjLen = 0;

	/**
	 *
	 * imges
	 *
	 * @param num
	 * @param type
	 * @param cnt
	 * @param obj
	 * @constructor
	 */
	var ColorChangeObjs = function ( num, type, cnt, obj ) {
		this._num   = num;
		this._type = type;
		this._cnt  = cnt;
		this.$displayObj = obj;

		this._imagePathArr = [];
		this._imageLoadedFlg = false;
		this._changeTimer = false;
		this._animatingFlg = false;
	};

	ColorChangeObjs.prototype = {

		init: function(){
			var num = this._num;

			var self = this;

			// Mouseover first time
			$.subscribe( COLOR_CHANGE_IMAGE_LOAD, function( num_ ){

				if( num === num_ ){
					self.imageLoadingPartAdd();
                                        self.colorChangeFunc();
				};
			});

			// mouseOver
			$.subscribe( COLOR_CHANGE_ICON_OVER, function( num_ ){
				if( num === num_ ){
					self.colorChangeFunc();
				};
			});
		},

		imageLoadingPartAdd: function(){
			var self = this;
			var hei = this.$displayObj.find('ul img').height();

			//
			if( this._type === TYPE_PLURAL ){
				if( $(window).width() <= oimc.generalSettings.breakPoint.POINT_C ){
					hei = hei * 2;
				};
			};

			this.$displayObj.append( '<div class="loading" style="width:100%; height:'+hei+'px; opacity:0;"><p style="text-align: center; margin: margin:0px auto;"><img src="/content/000000016.gif" alt="loading" /></p></div>' );

			// Ajust position
			this.$displayObj.find('.loading').css({ zIndex:100 })
				.find('> p').css({ marginTop:( hei - 44 ) /2 });

			this.$displayObj.find('.loading')
				.stop()
				.animate({
					opacity:1
				},{
					duration:400,
					complete:function(){
						if( self._type === TYPE_PLURAL ){
							self.imageLoadPrepare01();
						}else {
							self.imageLoadPrepare02();
						}
					}
				});
		},
		imageLoadPrepare01: function(){
			var self = this;
			var $iconLi = this.$displayObj.next().find('li'),
				len = this._cnt;

			var imagePathArr = [],
				imageArr= [];

			var i = 0,
				len = this._cnt;

			for(; i < len; i++){
				this._imagePathArr.push($iconLi.eq(i).find('a').attr('href'));
			};

			len = this._imagePathArr.length;

			for(i = 0; i < len; i++){
				// image load
				var imgObj = new Image();
				var imageLoadedCnt = 0;

				$( imgObj ).on("load", function(){
					// HACK:XXX Delay for IE7/8
					setTimeout(function(){
						imageLoadedCnt++;

						if( imageLoadedCnt >= self._cnt * 2 ){
							self.imageLoadingPartRemove();
						};
					},10 * i)
				} );

				imgObj.src = self._imagePathArr[i];
			};
		},

		imageLoadPrepare02: function(){
			var self = this;
			var $iconLi = this.$displayObj.next().find('li');

			var imagePathArr = [],
				imageArr= [];

			var i = 0,
				len = this._cnt;

			for(; i < len; i++){
				// Create array for imagePath
				var imagePath = $iconLi.eq(i).find('a').attr('href');
				this._imagePathArr.push(imagePath);
			};

			for(i = 0; i < len; i++){
				// image load
				var imgObj = new Image();
				var imageLoadedCnt = 0;

				$( imgObj ).on("load", function(e){
					// HACK: Delay for underIE8
					setTimeout(function(){
						imageLoadedCnt++;

						if( imageLoadedCnt >= self._cnt ){
							self.imageLoadingPartRemove();
						};
					},30)
				} );

				imgObj.src = self._imagePathArr[i];
			}
		},
		imageLoadingPartRemove: function(){
			var self = this;

			this.$displayObj.find('.loading')
				.stop()
				.animate({
					opacity:0
				},{
					duration:400,
					complete:function(){
						$(this).remove();
					}
				});

			self.imageLoaded();
		},
		imageLoaded: function(){
			this._imageLoadedFlg = true;

			$.publish( COLOR_CHANGE_IMAGE_LOADED, [this._num]);

			var i    = 1;
			var len  = this._imagePathArr.length;
			var href = this.$displayObj.find('a').attr('href');

			var linkFlg = typeof href !== 'undefined'

			// add to html
			var $addObj = this.$displayObj.find('ul');

			if( this._type === TYPE_PLURAL ){
				for(i = 2; i < len; i++){
					if( i % 2){
						if( linkFlg ){
							$addObj.append('<li class="back" style="bottom:0"><a href="'+ href +'"><img src="'+this._imagePathArr[i]+'" /></a></li>');
						}else {
							$addObj.append('<li class="back" style="bottom:0"><img src="'+this._imagePathArr[i]+'" /></li>');
						}
					}else {
						if( linkFlg ){
							$addObj.append('<li class="front" style="top:0"><a href="'+ href +'"><img src="'+this._imagePathArr[i]+'" /></a></li>');
						}else {
							$addObj.append('<li class="front" style="top:0"><img src="'+this._imagePathArr[i]+'" /></li>');
						}
					}
				};
			}else {
				for(i = 1; i < len; i++){
					if( linkFlg ){
						$addObj.append('<li><a href="'+ href +'"><img src="'+this._imagePathArr[i]+'" /></a></li>');
					}else {
						$addObj.append('<li><img src="'+this._imagePathArr[i]+'" /></li>');
					}
				};
			};

			// Set z-index
			var baseZindex = 100;
			$.each( this.$displayObj.find('li'), function(){
				$(this).css({ zIndex: --baseZindex })
			});

			this.colorChangeFunc();
		},

		colorChangeFunc: function(){
			// doCehck
			if( !this._imageLoadedFlg ){
				return
			};

			// Display
			var currentNum = colorIconArr[this._num].getOverdIconNum() - 1;
			var oldNum = colorIconArr[this._num].getOverdIcOldonNum() - 1;

			// doCheck!
			/*if( currentNum === oldNum ){
				return;
			};*/

			this._animatingFlg = true;

			// color change
			if( this._type === TYPE_PLURAL ){
				this.colorChangeFunc01(currentNum, oldNum);
			}else if( this._type === TYPE_ONCE ){
				this.colorChangeFunc02(currentNum, oldNum);
			}else {
				alert('Unexpected type');
			};
		},
		// Plural
		colorChangeFunc01:function(currentNum, oldNum){
			var speed = 400;
			var self = this;

			var i  = 0,
				len = this._cnt * 2;

			var currentFrontNum = currentNum * 2,
				currentBackNum  = currentNum * 2 + 1,
				oldFrontNum     = oldNum * 2,
				oldBackNum      = oldNum * 2 + 1;

			for(i = 0; i < len; i++){
				if( currentFrontNum === i || currentBackNum === i ){
					continue;
				};

				if( oldFrontNum === i || oldBackNum === i ){
					continue;
				};
			};
			// SHOW TYPE1-1
			if( currentNum < oldNum ){
				// old opacity1
				// front
				this.$displayObj.find('li:eq('+oldFrontNum+')')
					.css({ opacity: 1, display: '' });

				this.$displayObj.find('li:eq('+oldBackNum+')')
					.css({ opacity: 1, display: '' });

				// Show current
				// front
				this.$displayObj.find('li:eq('+currentFrontNum+')')
					.stop()
					.css({ display: '' })
					.animate({
						opacity:1
					},{
						duration: speed,
						complete:function(){
						}
					});
				this.$displayObj.find('li:eq('+currentBackNum+')')
					.stop()
					.css({ display: '' })
					.animate({
						opacity:1
					},{
						duration: speed,
						complete:function(){
							self.colorChangedFunc();
						}
					});
				// SHOW TYPE1-2
			}else if( currentNum > oldNum ) {
				// Delete old

				// front
				this.$displayObj.find('li:eq('+oldFrontNum+')')
					.stop()
					.animate({
						opacity:0
					},{
						duration: speed,
						complete:function(){
							self.colorChangedFunc();
							$(this).css({ display: 'none' });
						}
					});

				// back
				this.$displayObj.find('li:eq('+oldBackNum+')')
					.stop()
					.animate({
						opacity:0
					},{
						duration: speed,
						complete:function(){
							$(this).css({ display: 'none' });
						}
					});

				// current opacity1

				// front
				this.$displayObj.find('li:eq('+currentFrontNum+')')
					.css({ opacity: 1, display: '' });

				// back
				this.$displayObj.find('li:eq('+currentBackNum+')')
					.css({ opacity: 1, display: '' });
			}else {
				return;
			};
		},

		// Number of element is one
		colorChangeFunc02:function(currentNum, oldNum){
			var speed = 400;
			var self = this;

			var i  = 0,
				len = this._cnt;

			for(i = 0; i < len; i++){
				if( currentNum === i || oldNum === i ){
					continue;
				};

				this.$displayObj.find('li:eq('+i+')').css({ opacity: 0, display: 'none'})
			};

			// SHOW TYPE2-1
			if( currentNum < oldNum ){
				// old opacity1
				this.$displayObj.find('li:eq('+oldNum+')')
					.css({ opacity: 1, display: '' });

				// Show current
				this.$displayObj.find('li:eq('+currentNum+')')
					.stop()
					.css({ display: '' })
					.animate({
						opacity:1
					},{
						duration: speed,
						complete:function(){
							self.colorChangedFunc();
						}
					});
				// SHOW TYPE2-1
			}else if( currentNum > oldNum ) {
				// Delete old
				this.$displayObj.find('li:eq('+oldNum+')')
					.stop()
					.animate({
						opacity:0
					},{
						duration: speed,
						complete:function(){
							self.colorChangedFunc();
							$(this).css({ display: 'none' });
						}
					});

				// current opacity1
				this.$displayObj.find('li:eq('+currentNum+')')
					.css({ opacity: 1, display: '' });
			}else {
				return;
			}
		},

		colorChangedFunc: function() {
			// Measure moving mouse quickly
			var self = this;

			if ( this._changeTimer !== false ) {
				clearTimeout( showedTimer );
			};

			showedTimer = setTimeout( function(){

				if( self._type === TYPE_PLURAL){
					self.colorChangedFunc02_01();
				}else {
					self.colorChangedFunc02_02();
				}

			}, 10);
		},

		// plural
		colorChangedFunc02_01: function() {
			this._changeTimer = false;

			var currentNum = colorIconArr[this._num].getOverdIconNum() - 1;

			for(var i = 0; i < this._cnt; i++){

				if( i === currentNum ){
					continue;
				};

				this.$displayObj.find('li:eq(' + ( i * 2 ) + ')')
					.css({ opacity:0, display:'none' });

				this.$displayObj.find('li:eq(' + ( ( i * 2 ) + 1 ) + ')')
					.css({ opacity:0, display:'none' });
			};

			this._animatingFlg = false;
		},

		// Number of element is one
		colorChangedFunc02_02: function() {
			this._changeTimer = false;

			var currentNum = colorIconArr[this._num].getOverdIconNum() - 1;

			for(var i = 0; i < this._cnt; i++){

				if( i === currentNum ){
					continue;
				};

				this.$displayObj.find('li:eq(' + i + ')')
					.css({ opacity:0, display:'none' });
			}

			this._animatingFlg = false;
		},

		getAnimationgFlg: function(){
			// HACK:XXX
			return false
			// return this._animatingFlg;
		}
	};

	/**
	 *
	 * icons
	 *
	 * @param num
	 * @param type
	 * @param cnt
	 * @param obj
	 * @constructor
	 */
	var ColorIcons = function ( num, type, cnt, obj ) {
		this._num  = num;
		this._type = type;
		this._cnt  = cnt;
		this.$displayObj = obj;

		this._imageLoadedFlg = false;
		this._overdIconNum = 1;
		this._overdIconOldNum = 1;
	};

	ColorIcons.prototype = {
		init: function(){
			this.eventBind();

			var self = this;

			$.subscribe( COLOR_CHANGE_IMAGE_LOADED, function( num_ ){
				if( num_ === self._num_ ){
					self._imageLoadedFlg = true;
				};
			});
		},
		eventBind: function(){
			$(window).on('resize', imageSwitchResizeHandler);

			var $list = this.$displayObj.find('li');

			var self = this;

			var flg = false;

			imageSwitchResizeHandler();

			function imageSwitchResizeHandler(e){
				$(window).off('resize', imageSwitchResizeHandler);

				if( $(window).width() <= oimc.generalSettings.breakPoint.POINT_B ) {
					$list.find('a').off('mouseover focus', switching);
					$list.find('a').on('click', switching);
				} else {
					$list.find('a').off('click', switching);
					$list.find('a').on('mouseover focus', switching);
				}

				setTimeout(function(){
					$(window).on('resize', imageSwitchResizeHandler);
				}, 30)
			}

			function switching(e) {
				e.preventDefault();

				// Disable while animating
				var animationFlg = colorChangeArr[self._num].getAnimationgFlg();
				if( e.type === 'mouseover' && animationFlg ){
					return;
				};

				var src = $(this).attr('href');
				var num = $(this).parent().index() + 1;

				// Get icon number over element
				self._overdIconOldNum = self._overdIconNum;
				self._overdIconNum = num;

				// current
				self.$displayObj.find('.selected').removeClass('selected');
				$(this).parent().addClass('selected');

				if( !flg ){
					// Not load first element
					if( self._overdIconNum === 1 ){
						return;
					};

					flg = true;

					if( !self._imageLoadedFlg ){
						$.publish( COLOR_CHANGE_IMAGE_LOAD, [ self._num ]);
					};

				}else {
					$.publish( COLOR_CHANGE_ICON_OVER, [ self._num ]);
				};
			};

			$list.find('a').on('mouseout',function(e){

			});

			$list.find('a').on('click',function(e){
				e.preventDefault();
			});

		},

		getOverdIconNum: function(){
			return this._overdIconNum;
		},

		getOverdIcOldonNum: function(){
			return this._overdIconOldNum;
		}
	};

	var colorChangeArr = [];
	var colorIconArr   = [];

	function colorChangeBegin(){
		// doCheck
		if( $colorChangeContainer.length === 0 ){
			return;
		};

		var len = $colorChangeContainer.length;
		i   = 0;

		colorChangeObjLen = len;

		for(i = 0; i < len; i++){
			var $tempObj = $('.imageSwitch:eq('+i+')');

			var $tempImageObj = $tempObj.find('.productImage');
			var $tempIconObj = $tempObj.find('.switcher');

			// doCheck!
			if( $tempImageObj.length !== 1){
				alert('Unexpected productImage.length')
			};

			// doCheck!
			if( $tempIconObj.length !== 1){
				alert('Unexpected switcher.length')
			};

			var iconCnt = $tempIconObj.find('li').length;
			var type = TYPE_ONCE;

			if( $tempImageObj.find('li').length >= 2){
				type = TYPE_PLURAL;
			};

			colorChangeArr.push( new ColorChangeObjs( i, type, iconCnt, $tempImageObj) );
			colorIconArr.push( new ColorIcons( i, type, iconCnt, $tempIconObj) );
		};

		colorChangePrepare();
                $('.switcher li:first-child:last-child').html('<span class="noswitcher">&nbsp;<span>');
	};

	function colorChangePrepare(){
		var len = colorChangeObjLen;
		i   = 0;

		for(i = 0; i < len; i++) {
			colorChangeArr[i].init();
			colorIconArr[i].init();
		}
	};

	colorChangeBegin();

});